<template>
  <rui-loading v-if="loading"
               relative
               centered
               text="Loading document..."
               class="-mtl" />
  <template v-else>
    <header class="-mbl">
      <h1 class="-mb0">{{ describedComponent }}</h1>

      <div v-if="doc.sourceFiles.length > 0" class="-text--small">
        <strong>Sources:</strong>
        <code v-for="file in doc.sourceFiles" :key="file">{{ file }}</code>
      </div>
    </header>

    <rui-alert v-if="doc.deprecated" variant="warning" centered>
      <p>This component is deprecated and will be removed in the next major.</p>
      <p v-if="doc.deprecated !== true">{{ doc.deprecated }}</p>
    </rui-alert>

    <p v-if="doc.html && !doc.vuejs" class="-text--color-helping -mbl">
      This component is <em>HTML only</em>: it has no VueJS counterpart. Check the examples for ideas on how to use it.
    </p>
    <template v-else>
      <rui-alert v-if="!doc.description" variant="warning" class="-mbl">No description provided.</rui-alert>

      <doc-markdown-renderer v-else class="-mbl" document>{{ doc.description }}</doc-markdown-renderer>
    </template>

    <section v-if="doc.references.length > 0" class="-text--smaller">
      <h2>Also see</h2>
      <ul>
        <li v-for="line in doc.references" :key="line">
          <doc-markdown-renderer :raw="line" />
        </li>
      </ul>
    </section>

    <rui-tabs class="-mbd -mtl">
      <rui-button :active="$route.name === 'doc-api'" icon="doc:code" :disabled="!doc.vuejs" :to="{name: 'doc-api', params: {component: $route.params.component}}">API</rui-button>
      <rui-button :active="$route.name === 'doc-playground'" icon="doc:playground" :disabled="!hasPlayground" :to="{name: 'doc-playground', params: {component: $route.params.component}}">Playground</rui-button>
      <rui-button :active="$route.name === 'doc-vue'" icon="doc:file-vuejs" :disabled="!hasVueExamples" :to="{name: 'doc-vue', params: {component: $route.params.component}}">VueJS Examples</rui-button>
      <rui-button :active="$route.name === 'doc-html'" icon="doc:file-html" :disabled="!hasHtmlExamples" :to="{name: 'doc-html', params: {component: $route.params.component}}">HTML Examples</rui-button>
    </rui-tabs>

    <router-view />
  </template>
</template>

<script>
import { RuiAlert, RuiButton, RuiLoading, RuiTabs } from '../../src/components/index.js'
import DocMarkdownRenderer from '../components/MarkdownRenderer/MarkdownRenderer.vue'

export const childRoutes = [
  'doc-api',
  'doc-playground',
  'doc-vue',
  'doc-html',
]

export default {
  name: 'DocumentationView',
  components: { DocMarkdownRenderer, RuiLoading, RuiAlert, RuiTabs, RuiButton },
  data () {
    return {
      loading: false,
      describedComponent: null,
      doc: null,
      // For navigation guards
      childRoutes,
    }
  },
  computed: {
    hasVueExamples () { return this.doc.examples.vue.length > 0 },
    hasHtmlExamples () { return this.doc.examples.html.length > 0 },
    hasPlayground () { return this.doc.playground.enabled },
  },
  methods: {
    initialize () {
      // Force update
      this.loading = true
      const describedComponent = this.$route.params.component
      const doc = this.$getDoc(describedComponent)

      this.describedComponent = describedComponent
      this.doc = doc
      this.tab = doc.vuejs ? 'api' : 'html'
      this.$setTitle(`Component: ${describedComponent}`)

      setTimeout(() => { this.loading = false }, 100)
    },
  },
  created () {
    this.initialize()
  },
  watch: {
    // Reloads on same route if component changed
    $route (newValue, oldValue) {
      // Ignore navigation to another route
      if (!this.childRoutes.includes(newValue.name)) return
      // Ignore navigation to same component
      if (newValue.params.component === oldValue.params.component) return

      this.initialize()
    },
  },
}
</script>
